<template>
  <div class="signup">
    <form class="form">
      <h1>Đăng ký</h1>
      <div class="text_field">
        <input type="text" class="text_input" placeholder=" " v-model="username">
        <label class="text_label">Tên đăng nhập</label>
      </div>
      <div style="width: 10px"></div>
      <div style="display:flex; flex-direction: row;">
        <div class="text_field">
          <input type="text" class="text_input" placeholder=" " v-model="first_name">
          <label class="text_label">Họ</label>
        </div>
        <div class="text_field" style="margin-left: 10px;">
          <input type="text" class="text_input" placeholder=" " v-model="last_name">
          <label class="text_label">Tên</label>
        </div>
      </div>
      <div class="text_field">
        <input type="email" class="text_input" placeholder=" " v-model="email">
        <label class="text_label">Email</label>
      </div>
      <div class="text_field">
        <input type="password" class="text_input" placeholder=" " v-model="password">
        <label class="text_label">Mật khẩu</label>
      </div>
      <div class="text_field">
        <input type="password" class="text_input" placeholder=" " v-model="confirm">
        <label class="text_label">Xác nhận mật khẩu</label>
      </div>
      <div>
      <input type="checkbox" class="agreed" v-model="agree"> Tôi đã đọc và đồng ý điều khoản dịch vụ</div>
      <button v-if="agree" class="active" type="submit" @click.stop.prevent="signUp()">Đăng ký</button>
      <button v-else class="inactive" @click.stop.prevent="">Đăng ký</button>
      <div class="signin-link">Đã có tài khoản? 
        <router-link :to='{name:"Login", query: {link: link}}'>Đăng nhập</router-link>
      </div>
    </form>
  </div>
</template>

<script>
import UserService from '../services/UserService'

export default {
  name: 'Register-page',
  data() {
    return {      
      loading: false,
      username: '',      
      first_name: '',
      last_name: '',
      email: '',
      password: '',
      confirm: '',
      agree: false,
      link: this.$route.query.link,
    }
  },
  methods:{
    async signUp(){
      if(this.loading) return
      this.loading = true
      try{
        let response = await UserService.register({ 
          username: this.username,
          email: this.email,
          first_name: this.first_name,
          last_name: this.last_name,
          password: this.password
        })
        console.log(response)
        if(response.status == 200){
          let loginRes = await UserService.logIn({
            username: this.username,
            password: this.password
          })
          if(loginRes.status == 200){
            this.$store.dispatch('logIn', loginRes.data)
            if(!this.link) this.$router.push({ name: 'Home'})
            else this.$router.push({ path: this.link })
          }
          else this.$router.push({name: 'Login', query: {link: this.link}})
        }
        else{          
          alert(response.statusText)
        }        
      }
      catch(err){
        console.log(err)
        alert('Register Failed')
      }
      finally{
        this.loading = false
      }
    },
  }
}
</script>

<style scoped>
.signup{
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  justify-content: center;
  align-items: center;
}

.form{
  width: 360px;
  padding: 2rem;
  border-radius: 1rem;
  box-shadow: 0 10px 25px #ccc;
}

h1{
  text-align: center;
  font-weight: bold;
  margin-bottom: 3rem;
}

.text_field{
  height: 48px;
  width: 100%;  
  margin-bottom: 16px;
  border-bottom: 2px solid #666;
  display:flex 
}

.text_input{
  position: inherit;
  width: 100%;
  height: 100%;
  border: none;
  outline: none;
  background: none;
  z-index: 1; 
  font-size: 16px;
}


.text_label{
  position: absolute;
  transform: translate(0px,22px);
  background-color: #fff;
  color: black;
  font-size: 16px;
  transition: .3s;
  z-index: 2;
}

button{
  margin: 46px 0px;
  width: 100%;
  height: 48px;
  border-radius: 24px;
  font-size: 18px;
  outline: none;
}

.active {
  color: black;
  font-weight: bold;
  border: 1px solid #666;
  background-color: #eee;
}

.inactive {
  color: #666;
  font-weight: bold;
  border: 1px solid #666;
  background-color: #eee;
}


.text_input:focus + .text_label{
  transform: translateY(-2px);
  font-size: 12px;
  font-weight: 500;
}

.text_input:not(:placeholder-shown).text_input:not(:focus)+ .text_label{
  transform: translateY(-2px);
  font-size: 12px;
  font-weight: 500;
}

.active:hover{
  border-width: 2px;
  border-color: #333;
  cursor: pointer;
  background-color: #ccc;
} 

.agreed{
  margin-top: 16px;
}

.signin-link{
  text-align: center;
}
</style>